---
title: API references
slug: MDN/Structures/API_references
tags:
  - API
  - Contribute
  - Guide
  - Reference
---
<div>{{MDNSidebar}}</div>

<p class="summary">Client-side JavaScript APIs form a large part of the technology available on the web, and MDN includes extensive reference material to explain what functionality is available in these APIs, and how to use it. In this set of guides we explain how to create API reference material on MDN.</p>

<h2 id="Prerequisite_resources">Prerequisite resources</h2>

<p>Before starting to document an API, you should have available:</p>

<ol>
	<li><strong>The latest spec:</strong> Whether it is a W3C Recommendation or an early  editor's draft, you should refer to the latest available draft of the  spec that covers (or specs that cover) that API. To find it, you can usually do a Web search. The latest  version will often be linked to from all versions of the spec, listed under "latest draft" or similar.</li>
	<li><strong>The latest modern web browsers:</strong> These should be experimental/alpha builds such as <a href="https://nightly.mozilla.org/">Firefox Nightly</a>/<a href="https://www.google.com/intl/en/chrome/browser/canary.html">Chrome Canary</a> that are more likely to support the features you are documenting. This is especially pertinent if you are documenting a nascent/experimental API.</li>
	<li><strong>Demos/blog posts/other info:</strong> Find as much info as you can. It is useful to start by spending time familiarizing yourself with how the API works — learn what the main interfaces/properties/methods are, what the primary use cases are, and how to write simple functionality with it.</li>
	<li><strong>Useful engineering contacts:</strong> It is really useful to find yourself a friendly engineering contact to ask questions about the spec, someone who is involved in the standardization of the API, or its implementation in a browser. Good places to find them are:
	<ul>
		<li>Your internal company address book, if you work for a relevant company.</li>
		<li>A public mailing list that is involved in the discussion of that API,  such as Mozilla's <a href="https://lists.mozilla.org/listinfo/dev-platform">dev-platform</a> or <a href="https://lists.mozilla.org/listinfo/dev-webapi">dev-webapi</a> lists, or a W3C list like <a href="https://lists.w3.org/Archives/Public/public-webapps/">public-webapps</a>.</li>
		<li>The spec itself. For example, the <a href="https://webaudio.github.io/web-audio-api/">Web Audio API spec</a> lists the authors and their contact details at the top.</li>
	</ul>
	</li>
</ol>

<h2 id="High_level_structure">High level structure</h2>

<dl>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/API_references/What_does_an_API_reference_need">What does an API reference need?</a></dt>
	<dd>This article explains what pages are required for a complete API reference.</dd>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/Page_types">Page types</a></dt>
	<dd>There are a number of types of pages that are used repeatedly on MDN. This article describes these page types, their purpose, and gives examples of each and templates to use when creating a new page.</dd>
</dl>

<h2 id="Individual_page_features">Individual page features</h2>

<p>These articles explain how to create the individual page features required for API reference pages.</p>

<dl>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/API_references/API_reference_sidebars">API reference sidebars</a></dt>
	<dd>When including a sidebar on your MDN API reference articles, you are able to customize it so that it displays links to related Interfaces, tutorials, and other resources relevant just to that API. This article explains how.</dd>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/Syntax_sections">Syntax sections</a></dt>
	<dd>The syntax section of an MDN reference page contains a syntax box defining the exact syntax that a feature has (e.g. what parameters can it accept, which ones are optional?) This article explains how to write syntax boxes for refererence articles.</dd>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/Code_examples">Code examples</a></dt>
	<dd>On MDN, you'll see numerous code examples inserted throughout the pages to demonstrate usage of web platform features. This article discusses the different mechanisms available for adding code examples to pages, along with which ones you should use and when.</dd>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/Specification_tables">Specification tables</a></dt>
	<dd>Every reference page on MDN should provide information about the specification or specifications in which that API or technology was defined. This article demonstrates what these tables look like and explains how to construct them.</dd>
	<dt><a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables">Compatibility tables</a></dt>
	<dd>MDN has a standard format for compatibility tables for our open web documentation; that is, documentation of technologies such as the DOM, HTML, CSS, JavaScript, SVG, and so forth, that are shared across all browsers. This article covers how to use our features to add compatibility data to MDN pages.</dd>
</dl>
